## [PureMVC](http://puremvc.github.com/) JavaScript MultiCore Framework [![Node.js CI](https://github.com/PureMVC/puremvc-js-multicore-framework/actions/workflows/node.js.yml/badge.svg)](https://github.com/PureMVC/puremvc-js-multicore-framework/actions/workflows/node.js.yml)

PureMVC is a lightweight framework for creating applications based upon the classic [Model-View-Controller](http://en.wikipedia.org/wiki/Model-view-controller) design meta-pattern. It supports [modular programming](http://en.wikipedia.org/wiki/Modular_programming) through the use of [Multiton](http://en.wikipedia.org/wiki/Multiton) Core actors instead of the [Singletons](http://en.wikipedia.org/wiki/Singleton_pattern).

* [NPM Package](https://www.npmjs.com/package/@puremvc/puremvc-js-multicore-framework?activeTab=readme)
* [API Docs](https://puremvc.org/pages/docs/JS/es/)
* [Legacy Implementation](https://github.com/PureMVC/puremvc-js-multicore-framework/tree/1.0.1)

## Demos
* [Frontend Demo: EmployeeAdmin](https://github.com/PureMVC/puremvc-js-demo-employeeadmin)
* [Backend Demo: Employee Admin NodeJS Microservice](https://github.com/PureMVC/puremvc-js-demo-microservice-employeeadmin)

## Platforms / Technologies
* [JavaScript](https://en.wikipedia.org/wiki/JavaScript)
* [ECMAScript](https://en.wikipedia.org/wiki/ECMAScript)
* [CommonJS](https://en.wikipedia.org/wiki/CommonJS)
* [Node.js](https://en.wikipedia.org/wiki/Node.js)
* [React](https://en.wikipedia.org/wiki/React_(JavaScript_library))
* [React Native](https://en.wikipedia.org/wiki/React_Native)

## Status
Production - [Version 2.0.5](https://github.com/PureMVC/puremvc-js-multicore-framework/blob/master/VERSION)

#### Documentation
- https://jsdoc.app/about-commandline.html

#### Testing
- https://mochajs.org/
- https://sinonjs.org/
- [Nightwatch configuration example](https://gist.github.com/rebers/b640b1663c98d4436ecabb06270ff091)

### Project management
- https://stackabuse.com/the-ultimate-guide-to-configuring-npm/
- https://stackabuse.com/the-ultimate-guide-to-configuring-npm/
- https://nodesource.com/blog/the-basics-of-package-json-in-node-js-and-npm
- https://nodesource.com/blog/configuring-your-npmrc-for-an-optimal-node-js-environment
- https://www.freecodecamp.org/news/10-npm-tricks-that-will-make-you-a-pro-a945982afb25/
- https://flaviocopes.com/package-json/
- https://www.toptal.com/javascript/a-guide-to-npm-the-node-package-manager
- https://github.com/lorenwest/node-config
- https://docs.npmjs.com/package-name-guidelines

## License
* PureMVC MultiCore Framework for JavaScript - Copyright © 2023 [Saad Shams](https://www.linkedin.com/in/muizz), [David Foley](https://github.com/objectkit), [Cliff Hall](https://www.linkedin.com/in/cliff)
* PureMVC - Copyright © 2023 [Futurescale, Inc.](http://futurescale.com/)
* All rights reserved.

* Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

  * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
  * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
  * Neither the name of Futurescale, Inc., PureMVC.org, nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
